package org.playframework.playtools.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.window.ApplicationWindow;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

public  abstract class PlayActionBase  implements IWorkbenchWindowActionDelegate {
	protected IWorkbenchWindow window;

	public void run(IAction action) {
		try{
			window.getShell().setCursor(new Cursor(window.getShell().getDisplay(), SWT.CURSOR_WAIT));
			internalRun();
      	} catch(Exception e){
			MessageDialog.openError(window.getShell(), "Error", e.getMessage());
  		} finally {
  			window.getShell().setCursor(new Cursor(window.getShell().getDisplay(), SWT.CURSOR_ARROW));
  			((ApplicationWindow)window).setStatus(null);
  		}
	}

	protected abstract void internalRun() throws Exception;

	public void selectionChanged(IAction action, ISelection selection) {}

	public void dispose() {}

	public void init(IWorkbenchWindow window) {
		this.window = window;
	}

}
