package org.playframework.playtools.util.console;

import org.eclipse.debug.core.IStreamListener;
import org.eclipse.debug.core.model.IStreamMonitor;
import org.eclipse.swt.graphics.Color;
import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleManager;
import org.eclipse.ui.console.MessageConsole;
import org.eclipse.ui.console.MessageConsoleStream;
import org.playframework.playtools.PlayToolsPlugin;

public class PlayMessageConsole {
	private static IConsoleManager consolManager = null;
	private static MessageConsole messageConsole = null;
	private static MessageConsoleStream consolStream = null;
	private String name = null;
	
	public PlayMessageConsole() {
	}
	
	public PlayMessageConsole(String name) {
		this.name= name; 

		if (messageConsole != null) {
			consolManager.removeConsoles(new IConsole[] {messageConsole});
			messageConsole = null;
			consolStream = null;
		}
		
		messageConsole = createConsole(name);
		
		consolStream = messageConsole.newMessageStream();
	    consolStream.setColor(new Color(PlayToolsPlugin.getDefault().getWorkbench().getDisplay(), 0, 0, 0));
	    consolManager = ConsolePlugin.getDefault().getConsoleManager();
	    consolManager.addConsoles(new IConsole[] {messageConsole});
	    consolManager.showConsoleView(messageConsole);
	}

	public void println(String msg) {
		consolStream.println(msg);
	}
	
	private MessageConsole createConsole(String name) { 
		ConsolePlugin plugin = ConsolePlugin.getDefault();
		IConsoleManager conMan = plugin.getConsoleManager();
		IConsole[] consoles = conMan.getConsoles(); 

		for (IConsole element : consoles) {
			if (name.toString().compareTo(element.getName()) == 0) {
				return (MessageConsole) element; 
			}
		}
		MessageConsole newConsole = new MessageConsole(name.toString(), null);
		//conMan.addConsoles(new IConsole[] { newConsole });
	  
		return newConsole; 
	}

	private IStreamListener streamListener = new IStreamListener() {
		public void streamAppended(String text, IStreamMonitor monitor) {
			MessageConsoleStream streamOutput = consolStream;
			if (streamOutput != null) {
				streamOutput.print(text);
			}
		}
	};

	public IStreamListener getListener() {
		return streamListener;
	}
}
