package org.playframework.playtools.util.invoker;

import org.playframework.playtools.util.console.PlayMessageConsole;

public class PlayInvokerVersion2 extends AbstractPlayInvoker {
	private static Play2Launcher lancher = null;
	
	public PlayInvokerVersion2() {
	}
	
	public PlayInvokerVersion2(String payRootPath, String version, String projectPath, String port) {
		this.payRootPath = payRootPath;
		this.version = version;
		this.projectPath = projectPath;
		this.port = port;

		consoleTitle = "play framework";
	}

	public void stopPlay() {
		if (lancher != null) {
			if (messageConsole != null) {
				messageConsole.println("\n" + consoleTitle + " version " + version + " stop...");
			}
			
			lancher.terminate();
			
			lancher = null;
		}
	}

	protected void launchPlay() {

		messageConsole = new PlayMessageConsole(consoleTitle);
		
		lancher = new Play2Launcher(messageConsole);

		messageConsole.println(consoleTitle + " version " + version + " start...");
		
		lancher.execPlay(payRootPath, version, projectPath, port);
		
	}

}
